<?php
class Route {
    private static $error = true;
    private static $extension = null;
    private static $case_sensitive = true;
    public static function CONFIG($config = array()) {
        if (is_array($config)) {
            if (isset($config["extension"])) {
                self::$extension = $config["extension"];
            }
            if (isset($config["case_sensitive"])) {
                self::$case_sensitive = $config["case_sensitive"];
            }
        } else {
            echo "<font color='red'>Config method can only take array values as parameter!</font>";
            exit;
        }
    }
    public static function GET($pattern, $function) {
        if (!is_string($pattern)) {
            echo "<font color='red'>The first parameter of the get method can take string values!</font>";
            exit;
        }
        if (!is_string($function) && !is_callable($function)) {
            echo "<font color='red'>The second parameter of the get method must be a string value or a function!</font>";
            exit;
        }
        if (self::$extension != null && $pattern != "/") {
            $pattern = $pattern . "." . self::$extension;
        }
        if ($pattern != "/") {
            $pattern = "/" . $pattern;
        }
        self::run($pattern, $function, "GET");
    }
    public static function POST($pattern, $function) {
        if (!is_string($pattern)) {
            echo "<font color='red'>The first parameter of the post method can take string values!</font>";
            exit;
        }
        if (!is_string($function) && !is_callable($function)) {
            echo "<font color='red'>The second parameter of the Post method must be a string value or a function!</font>";
            exit;
        }
        if (self::$extension != null && $pattern != "/") {
            $pattern = $pattern . "." . self::$extension;
        }
        if ($pattern != "/") {
            $pattern = "/" . $pattern;
        }
        self::run($pattern, $function, "POST");
    }
    public static function ERROR($function) {
        if (self::$error == true) {
            call_user_func($function);
        }
    }
    private static function run($pattern, $function, $method) {
        if (empty($pattern) || empty($function) || empty($method)) {
            echo "<font color='red'>Parameter missing!</font>";
            exit;
        }
        $path_info = empty($_SERVER["PATH_INFO"]) ? "/" : $_SERVER["PATH_INFO"];
        $pattern = str_replace("(:any)", "(.*?)", $pattern);
        $pattern = str_replace("(:number)", "(\d+)", $pattern);
        if (self::$case_sensitive == false) {
            $pattern = "#^$pattern$#";
        } else {
            $pattern = "#^$pattern$#i";
        }
        if (preg_match($pattern, $path_info, $param) && $_SERVER["REQUEST_METHOD"] == $method) {
            if (is_callable($function)) {
                array_shift($param);
                call_user_func_array($function, $param);
            } else if (is_string($function)) {
                $control = explode("@", $function);
                if (count($control) == 1) {
                    if (is_callable($function)) {
                        call_user_func($function);
                    } else {
                        echo "<font color='red'>Function not found!</font>";
                        exit;
                    }
                } else {
                    if (method_exists($control[0], $control[1])) {
                        array_shift($param);
                        $class = new $control[0]();
                        call_user_func_array(array($class, $control[1]), $param);
                    } else {
                        echo "<font color='red'>Class not found!</font>";
                        exit;
                    }
                }
            }
            self::$error = false;
        }
    }
}
if (file_exists("application/config/config-db.php")) {
} else {
    header('Location: install');
}
require_once ("application/routes.php");
?>